#! /usr/bin/env bash

# SPDX-FileCopyrightText: 2024 eclipse foundation
# SPDX-License-Identifier: EPL-2.0

# * Generate <instance>/target/config.json file
# * Call gen-mvn-settings.sh script

# set -o errexit
# set -o nounset
# set -o pipefail

: "${GRAC_DEBUG:=""}"
[[ -n "${GRAC_DEBUG}" ]] && [[ "${GRAC_DEBUG}" == "true" ]] && set -x

DRY_MESSAGE=""
: "${GRAC_DRY:=""}"
[[ -n "${GRAC_DRY}" ]] && [[ "${GRAC_DRY}" == "true" ]] && DRY_MESSAGE="Dry mode (ON)"

IFS=$'\n\t'
SCRIPT_FOLDER="$(dirname "$(readlink -f "${BASH_SOURCE[0]}")")"

# shellcheck disable=SC1091
. "${SCRIPT_FOLDER}/log.sh"

# shellcheck disable=SC1091
 . "${SCRIPT_FOLDER}/gitlab_context.sh"

log info  "############################ START registration ${DRY_MESSAGE} ############################"

# shellcheck disable=SC1091
. "${SCRIPT_FOLDER}/k8s-context.sh" 

instance="${1:-}"
deployment="${2:-}"

start=$(date +"%s")

if [ -z "${instance}" ]; then
  log error "You must provide an 'instance' name argument"
  exit 1
fi

if [ ! -d "${instance}/${CURRENT_CLUSTER_CONTEXT}" ]; then
  log warn "No 'instance' found at '${instance}/${CURRENT_CLUSTER_CONTEXT}' \n" \
            "Create a new instance with : './grac.sh create ${instance##*/}'" 
  exit 
fi

target="${instance}/${CURRENT_CLUSTER_CONTEXT}/target"

# create all directories
rm -rf "${target:?}/*" 2> /dev/null || true
mkdir -p "${target}/k8s/.secrets"

GRAC_VERSION="$(grep -oP '(?<="version": ")[^"]*' ${SCRIPT_FOLDER}/../bpkg.json)"

JSONNET_PARAM=(
  "--ext-str" "cluster=${CURRENT_CLUSTER_CONTEXT}" \
  "--ext-str" "currentDate=$(date "+%F-%T")" \
  "--ext-str" "gracVersion=${GRAC_VERSION}"
) 

load_pĥase() {
  local phase_number="${1:-}"

  log info "########## Phase ${phase_number} ##########"
  if [[ -f "${instance}/grac-phase${phase_number}.libsonnet" ]]; then
    # note the -J as we will need to import config.json as generated by phase 1
    jsonnet -m "${target}" -J "${instance}/${CURRENT_CLUSTER_CONTEXT}/target" "${instance}/grac-phase-${phase_number}.libsonnet" "${JSONNET_PARAM[@]}"
  else 
    # otherwise, take the one from the templates.
    # note the -J as we will need to import config.json as generated by phase 1
    jsonnet -m "${target}" -J "${instance}/${CURRENT_CLUSTER_CONTEXT}/target" "${SCRIPT_FOLDER}/../templates/grac-phase-${phase_number}.libsonnet" "${JSONNET_PARAM[@]}"
  fi
}
 
CONFIG_JSON="${instance}/${CURRENT_CLUSTER_CONTEXT}/target/config.json"

if [[ ! -f "${CONFIG_JSON}" ]]; then
  log error "No config.json found at '${CONFIG_JSON}', please run first './grac.sh k8s ${instance}'"
  exit 1
fi

getRunnerToken() {
  local namespace=$1
  local deploymentType=$2
  local instance=$3

  local deploymentctx
  local deploymentctxActive
  local runnerToken=""

  deploymentctx=$(jq -r --arg deploymentType "${deploymentType}" '.deploymentctx[$deploymentType]' "${CONFIG_JSON}")
  deploymentctxActive=$(echo "${deploymentctx}" | jq -r '.active == true')
  
  if [[ "${deploymentctxActive}" == true ]]; then
    deploymentctxActive=$(echo "${deploymentctx}" | jq -r '.active == true')
    runner_name=$(echo "${deploymentctx}" | jq -r '.ctx')
    runner_description=$(echo "${deploymentctx}" | jq -r '.runner.register.description')
    [[ -z "${runner_description}" ]] && runner_description="${runner_name} runner"
    runner_locked=$(echo "${deploymentctx}" | jq -r '.runner.register.locked')
    runner_taglist=$(echo "${deploymentctx}" | jq -r '.runner.env.runner.tagList')
    runner_untagged=$(echo "${deploymentctx}" | jq -r '.runner.register.runUntagged')

    echo -e "Generate runner ${deploymentType} with: \n \
     name: ${runner_name}, \n \
     description: ${runner_description}, \n \
     locked: ${runner_locked}, \n \
     taglist: ${runner_taglist}, \n \
     untagged: ${runner_untagged}"

    runnerToken=$("${SCRIPT_FOLDER}/gitlab_runner_admin.sh" get_runner_token "${namespace}" "${runner_name}" "${runner_description}" "${runner_locked}" "${runner_untagged}" "${runner_taglist}")
    if [[ -z "${runnerToken}" ]] || [[ "${runnerToken}" == "null" ]]; then
      log error "Can't obtain runner token for runner ${deploymentType} in instance ${instance}"
      exit 1
    fi
    log info "Runner token for ${deploymentType} acquired"
    JSONNET_PARAM+=(
      "--ext-str" "runnerToken=${runnerToken}" 
      "--ext-str" "deploymentctx=${deploymentType}" 
    )
  
    load_pĥase "registration" # secret management 
  else
    log info "Runner ${deploymentType} deactivated"
  fi
}

# get namespace project in gitlab
allDeploymentTypes="$(jq -r '.deploymentctx | to_entries' "${CONFIG_JSON}" | jq -r '.[].key')"
deploymentNamespace="$(jq  -r  '.deployment.namespace' "${CONFIG_JSON}")"
for deploymentType in ${allDeploymentTypes} 
do
  deploymentCtxNamespace="$(jq  -r --arg deploymentctx "${deploymentType}" '.deploymentctx | .[$deploymentctx] | .namespace' "${CONFIG_JSON}")"
  [[ -z ${deploymentCtxNamespace} || "${deploymentCtxNamespace}" == "null" ]] && deploymentCtxNamespace="${deploymentNamespace}"

  if [[ -n "${deployment}" ]]; then 
    if [[ "${deployment}" == "${deploymentType}" ]]; then
      getRunnerToken "${deploymentCtxNamespace}" "${deploymentType}" "${instance}"
      break
    fi
  else
    getRunnerToken "${deploymentCtxNamespace}" "${deploymentType}" "${instance}"
  fi        
done


end=$(date +"%s")
runtime=$(echo "$end - $start" | bc -l)
log info  "############################ END registration in ${runtime}s ############################"


